#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy2 Experiment Builder (v1.85.2),
    on Sun Dec  3 12:15:23 2017
If you publish work using this script please cite the PsychoPy publications:
    Peirce, JW (2007) PsychoPy - Psychophysics software in Python.
        Journal of Neuroscience Methods, 162(1-2), 8-13.
    Peirce, JW (2009) Generating stimuli for neuroscience using PsychoPy.
        Frontiers in Neuroinformatics, 2:10. doi: 10.3389/neuro.11.010.2008
"""

from __future__ import absolute_import, division
from psychopy import locale_setup, sound, gui, visual, core, data, event, logging
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)
import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding

# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__)).decode(sys.getfilesystemencoding())
os.chdir(_thisDir)

# Store info about the experiment session
expName = 'digit_WM_experiment'  # from the Builder filename that created this script
expInfo = {u'session': u'001', u'participant': u''}
dlg = gui.DlgFromDict(dictionary=expInfo, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath=None,
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

# list where I save the points for each set size (2 for first right, 1 for second right, 0 for none right) 
scoreList = []

endExpNow = False  # flag for 'escape' or other condition => quit the exp

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=(1440, 900), fullscr=True, screen=0,
    allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True)
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# Initialize components for Routine "instr"
instrClock = core.Clock()
Instructions = visual.TextStim(win=win, name='Instructions',
    text="You are going to see some numbers one at a time on the screen. After each set of numbers, you will see a question mark. When you see the question mark I want you to tell me the numbers you saw in size order from smallest to biggest. For example, if I show you 37, 15, 52, I want you to say 15, 37, 52. Do you have any questions? Let's practice.",
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0, alignHoriz = 'center', alignVert = 'center');

# Initialize components for Routine "prac1"
prac1Clock = core.Clock()
pseq1 = visual.TextStim(win=win, name='pseq1',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "pWait"
pWaitClock = core.Clock()
questionMark = visual.TextStim(win=win, name='questionMark',
    text='?',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "ready"
readyClock = core.Clock()
areYouReady = visual.TextStim(win=win, name='areYouReady',
    text=u'Are you ready?',
    font=u'Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color=u'black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "prac2"
prac2Clock = core.Clock()
pseq2 = visual.TextStim(win=win, name='pseq2',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "instr2"
instr2Clock = core.Clock()
realInstructions = visual.TextStim(win=win, name='realInstructions',
    text=u"Let's look at some more numbers. Remember, after you see the numbers, you will see a question mark. Once you see the question mark, I want you to tell me what you just saw in size order from smallest to biggest.",
    font=u'Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color=u'black', colorSpace='rgb', opacity=1,
    depth=0.0, alignHoriz = 'center', alignVert = 'center');

# Initialize components for Routine "two1"
two1Clock = core.Clock()
two1dig = visual.TextStim(win=win, name='two1dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "two2"
two2Clock = core.Clock()
two2dig = visual.TextStim(win=win, name='two2dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "wait"
waitClock = core.Clock()
qMark = visual.TextStim(win=win, name='qMark',
    text=u'?',
    font=u'Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color=u'black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "endTest"
endTestClock = core.Clock()
goodJobEndTest = visual.TextStim(win=win, name='goodJobEndTest',
    text=u'Good job! \n(End test)',
    font=u'Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color=u'black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "three1"
three1Clock = core.Clock()
three1dig = visual.TextStim(win=win, name='three1dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);
    

# Initialize components for Routine "three2"
three2Clock = core.Clock()
three2dig = visual.TextStim(win=win, name='three2dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "four1"
four1Clock = core.Clock()
four1dig = visual.TextStim(win=win, name='four1dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);
    
# Initialize components for Routine "four2"
four2Clock = core.Clock()
four2dig = visual.TextStim(win=win, name='four2dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);
    
    
# Initialize components for Routine "five1"
five1Clock = core.Clock()
five1dig = visual.TextStim(win=win, name='five1dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "five2"
five2Clock = core.Clock()
five2dig = visual.TextStim(win=win, name='five2dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "six1"
six1Clock = core.Clock()
six1dig = visual.TextStim(win=win, name='six1dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "six2"
six2Clock = core.Clock()
six2dig = visual.TextStim(win=win, name='six2dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "seven1"
seven1Clock = core.Clock()
seven1dig = visual.TextStim(win=win, name='seven1dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "seven2"
seven2Clock = core.Clock()
seven2dig = visual.TextStim(win=win, name='seven2dig',
    text='default text',
    font=u'Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "instr"-------
t = 0
instrClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
click_to_start = event.BuilderKeyResponse()
# keep track of which components have finished
instrComponents = [Instructions, click_to_start]
for thisComponent in instrComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "instr"-------
while continueRoutine:
    # get current time
    t = instrClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Instructions* updates
    if t >= 0 and Instructions.status == NOT_STARTED:
        # keep track of start time/frame for later
        Instructions.tStart = t
        Instructions.frameNStart = frameN  # exact frame index
        Instructions.setAutoDraw(True)
    
    # *click_to_start* updates
    if t >= 0.0 and click_to_start.status == NOT_STARTED:
        # keep track of start time/frame for later
        click_to_start.tStart = t
        click_to_start.frameNStart = frameN  # exact frame index
        click_to_start.status = STARTED
        # keyboard checking is just starting
    if click_to_start.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instrComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "instr"-------
for thisComponent in instrComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "instr" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()


# ------Prepare to start Routine "ready"-------
t = 0
readyClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
clickWhenReady = event.BuilderKeyResponse()
# keep track of which components have finished
readyComponents = [areYouReady, clickWhenReady]
for thisComponent in readyComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "ready"-------
while continueRoutine:
    # get current time
    t = readyClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *areYouReady* updates
    if t >= 0.0 and areYouReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        areYouReady.tStart = t
        areYouReady.frameNStart = frameN  # exact frame index
        areYouReady.setAutoDraw(True)
    
    # *clickWhenReady* updates
    if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        clickWhenReady.tStart = t
        clickWhenReady.frameNStart = frameN  # exact frame index
        clickWhenReady.status = STARTED
        # keyboard checking is just starting
    if clickWhenReady.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ready"-------
for thisComponent in readyComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ready" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# -------2.0 sec delay before showing numbers-------
blnk = visual.TextStim(win, text=u"    ")
blnk.draw()
win.flip()
core.wait(0.5)

# set up handler to look after randomisation of conditions etc
numbers_p1 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1'),
    seed=None, name='numbers_p1')
thisExp.addLoop(numbers_p1)  # add the loop to the experiment
thisNumbers_p1 = numbers_p1.trialList[0]  # so we can initialise stimuli with some values

# abbreviate parameter names if possible (e.g. rgb = thisNumbers_p1.rgb)
if thisNumbers_p1 != None:
    for paramName in thisNumbers_p1.keys():
        exec(paramName + '= thisNumbers_p1.' + paramName)

for thisNumbers_p1 in numbers_p1:
    currentLoop = numbers_p1
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers_p1.rgb)
    if thisNumbers_p1 != None:
        for paramName in thisNumbers_p1.keys():
            exec(paramName + '= thisNumbers_p1.' + paramName)
    
    # ------Prepare to start Routine "prac1"-------
    t = 0
    prac1Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(2.000000)
    # update component parameters for each repeat
    pseq1.setText(int(P1))
    # keep track of which components have finished
    prac1Components = [pseq1]
    for thisComponent in prac1Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "prac1"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = prac1Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *pseq1* updates
        if t >= 0 and pseq1.status == NOT_STARTED:
            # keep track of start time/frame for later
            pseq1.tStart = t
            pseq1.frameNStart = frameN  # exact frame index
            pseq1.setAutoDraw(True)
        frameRemains = 0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if pseq1.status == STARTED and t >= frameRemains:
            pseq1.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in prac1Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "prac1"-------
    for thisComponent in prac1Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
# completed 1 repeats of 'numbers_p1'


# ------Prepare to start Routine "pWait"-------
t = 0
pWaitClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
waitResp = event.BuilderKeyResponse()
# keep track of which components have finished
pWaitComponents = [questionMark, waitResp]
for thisComponent in pWaitComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "pWait"-------
while continueRoutine:
    # get current time
    t = pWaitClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *questionMark* updates
    if t >= 0.0 and questionMark.status == NOT_STARTED:
        # keep track of start time/frame for later
        questionMark.tStart = t
        questionMark.frameNStart = frameN  # exact frame index
        questionMark.setAutoDraw(True)
    
    # *waitResp* updates
    if t >= 0.0 and waitResp.status == NOT_STARTED:
        # keep track of start time/frame for later
        waitResp.tStart = t
        waitResp.frameNStart = frameN  # exact frame index
        waitResp.status = STARTED
        # keyboard checking is just starting
    if waitResp.status == STARTED:
        theseKeys = event.getKeys(keyList=['0', '1'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if "0" in theseKeys:
            scoreList.append(0)
            thisExp.addData('setScore',0)
        elif "1" in theseKeys: 
            scoreList.append(1)
            thisExp.addData('setScore',1)
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in pWaitComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "pWait"-------
for thisComponent in pWaitComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "pWait" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "ready"-------
t = 0
readyClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
clickWhenReady = event.BuilderKeyResponse()
# keep track of which components have finished
readyComponents = [areYouReady, clickWhenReady]
for thisComponent in readyComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "ready"-------
while continueRoutine:
    # get current time
    t = readyClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *areYouReady* updates
    if t >= 0.0 and areYouReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        areYouReady.tStart = t
        areYouReady.frameNStart = frameN  # exact frame index
        areYouReady.setAutoDraw(True)
    
    # *clickWhenReady* updates
    if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        clickWhenReady.tStart = t
        clickWhenReady.frameNStart = frameN  # exact frame index
        clickWhenReady.status = STARTED
        # keyboard checking is just starting
    if clickWhenReady.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ready"-------
for thisComponent in readyComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ready" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# -------0.5 sec delay before showing numbers-------
blnk = visual.TextStim(win, text=u"    ")
blnk.draw()
win.flip()
core.wait(0.5)

# set up handler to look after randomisation of conditions etc
numbers_p2 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2'),
    seed=None, name='numbers_p2')
thisExp.addLoop(numbers_p2)  # add the loop to the experiment
thisNumbers_p2 = numbers_p2.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisNumbers_p2.rgb)
if thisNumbers_p2 != None:
    for paramName in thisNumbers_p2.keys():
        exec(paramName + '= thisNumbers_p2.' + paramName)

for thisNumbers_p2 in numbers_p2:
    currentLoop = numbers_p2
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers_p2.rgb)
    if thisNumbers_p2 != None:
        for paramName in thisNumbers_p2.keys():
            exec(paramName + '= thisNumbers_p2.' + paramName)
    
    # ------Prepare to start Routine "prac2"-------
    t = 0
    prac2Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(2.000000)
    # update component parameters for each repeat
    pseq2.setText(int(P2))
    # keep track of which components have finished
    prac2Components = [pseq2]
    for thisComponent in prac2Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "prac2"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = prac2Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *pseq2* updates
        if t >= 0.0 and pseq2.status == NOT_STARTED:
            # keep track of start time/frame for later
            pseq2.tStart = t
            pseq2.frameNStart = frameN  # exact frame index
            pseq2.setAutoDraw(True)
        frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if pseq2.status == STARTED and t >= frameRemains:
            pseq2.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in prac2Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "prac2"-------
    for thisComponent in prac2Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
# completed 1 repeats of 'numbers_p2'


# ------Prepare to start Routine "pWait"-------
t = 0
pWaitClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
waitResp = event.BuilderKeyResponse()
# keep track of which components have finished
pWaitComponents = [questionMark, waitResp]
for thisComponent in pWaitComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "pWait"-------
while continueRoutine:
    # get current time
    t = pWaitClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *questionMark* updates
    if t >= 0.0 and questionMark.status == NOT_STARTED:
        # keep track of start time/frame for later
        questionMark.tStart = t
        questionMark.frameNStart = frameN  # exact frame index
        questionMark.setAutoDraw(True)
    
    # *waitResp* updates
    if t >= 0.0 and waitResp.status == NOT_STARTED:
        # keep track of start time/frame for later
        waitResp.tStart = t
        waitResp.frameNStart = frameN  # exact frame index
        waitResp.status = STARTED
        # keyboard checking is just starting
    if waitResp.status == STARTED:
        theseKeys = event.getKeys(keyList=['0','1'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if "0" in theseKeys:
            scoreList.append(0)
            thisExp.addData('setScore',0)
        elif "1" in theseKeys: 
            scoreList.append(1)
            thisExp.addData('setScore',1)
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in pWaitComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "pWait"-------
for thisComponent in pWaitComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "pWait" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "instr2"-------
t = 0
instr2Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
clicktoReady = event.BuilderKeyResponse()
# keep track of which components have finished
instr2Components = [realInstructions, clicktoReady]
for thisComponent in instr2Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "instr2"-------
while continueRoutine:
    # get current time
    t = instr2Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *realInstructions* updates
    if t >= 0.0 and realInstructions.status == NOT_STARTED:
        # keep track of start time/frame for later
        realInstructions.tStart = t
        realInstructions.frameNStart = frameN  # exact frame index
        realInstructions.setAutoDraw(True)
    
    # *clicktoReady* updates
    if t >= 0.0 and clicktoReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        clicktoReady.tStart = t
        clicktoReady.frameNStart = frameN  # exact frame index
        clicktoReady.status = STARTED
        # keyboard checking is just starting
        clicktoReady.clock.reset()  # now t=0
    if clicktoReady.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            clicktoReady.keys = theseKeys[-1]  # just the last key pressed
            clicktoReady.rt = clicktoReady.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instr2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "instr2"-------
for thisComponent in instr2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if clicktoReady.keys in ['', [], None]:  # No response was made
    clicktoReady.keys=None

thisExp.nextEntry()
# the Routine "instr2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ********************************START TWO SET****************************************


# ------Prepare to start Routine "ready"-------
t = 0
readyClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
clickWhenReady = event.BuilderKeyResponse()
# keep track of which components have finished
readyComponents = [areYouReady, clickWhenReady]
for thisComponent in readyComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "ready"-------
while continueRoutine:
    # get current time
    t = readyClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *areYouReady* updates
    if t >= 0.0 and areYouReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        areYouReady.tStart = t
        areYouReady.frameNStart = frameN  # exact frame index
        areYouReady.setAutoDraw(True)
    
    # *clickWhenReady* updates
    if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        clickWhenReady.tStart = t
        clickWhenReady.frameNStart = frameN  # exact frame index
        clickWhenReady.status = STARTED
        # keyboard checking is just starting
    if clickWhenReady.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ready"-------
for thisComponent in readyComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ready" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# -------2.0 sec delay before showing numbers-------
blnk = visual.TextStim(win, text=u"    ")
blnk.draw()
win.flip()
core.wait(0.5)

# set up handler to look after randomisation of conditions etc
numbers21 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1'),
    seed=None, name='numbers21')
thisExp.addLoop(numbers21)  # add the loop to the experiment
thisNumbers21 = numbers21.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisNumbers21.rgb)
if thisNumbers21 != None:
    for paramName in thisNumbers21.keys():
        exec(paramName + '= thisNumbers21.' + paramName)

for thisNumbers21 in numbers21:
    currentLoop = numbers21
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers21.rgb)
    if thisNumbers21 != None:
        for paramName in thisNumbers21.keys():
            exec(paramName + '= thisNumbers21.' + paramName)
    
    # ------Prepare to start Routine "two1"-------
    t = 0
    two1Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(2.000000)
    # update component parameters for each repeat
    two1dig.setText(int(S21))
    # keep track of which components have finished
    two1Components = [two1dig]
    for thisComponent in two1Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "two1"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = two1Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text* updates
        if t >= 0.0 and two1dig.status == NOT_STARTED:
            # keep track of start time/frame for later
            two1dig.tStart = t
            two1dig.frameNStart = frameN  # exact frame index
            two1dig.setAutoDraw(True)
        frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if two1dig.status == STARTED and t >= frameRemains:
            two1dig.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in two1Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "two1"-------
    for thisComponent in two1Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
# completed 1 repeats of 'numbers21'


# ------Prepare to start Routine "wait"-------
t = 0
waitClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
subResp = event.BuilderKeyResponse()
# keep track of which components have finished
waitComponents = [qMark, subResp]
for thisComponent in waitComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "wait"-------
while continueRoutine:
    # get current time
    t = waitClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *qMark* updates
    if t >= 0.0 and qMark.status == NOT_STARTED:
        # keep track of start time/frame for later
        qMark.tStart = t
        qMark.frameNStart = frameN  # exact frame index
        qMark.setAutoDraw(True)
    
    # *subResp* updates
    if t >= 0.0 and subResp.status == NOT_STARTED:
        # keep track of start time/frame for later
        subResp.tStart = t
        subResp.frameNStart = frameN  # exact frame index
        subResp.status = STARTED
        # keyboard checking is just starting
        subResp.clock.reset()  # now t=0
    if subResp.status == STARTED:
        theseKeys = event.getKeys(keyList=['0', '1'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            subResp.keys = theseKeys[-1]  # just the last key pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "wait"-------
for thisComponent in waitComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if subResp.keys in ['', [], None]:  # No response was made
    subResp.keys=None
if subResp.keys == '0': 
    incorrect = 1
elif subResp.keys == '1': 
    incorrect = 0
    scoreList.append(2) # Otherwise, wait til next round and see if we should add a one 
    thisExp.addData('setScore',2)
    # or a zero for this set size

thisExp.nextEntry()
# the Routine "wait" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
runIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='runIfWrong')
thisExp.addLoop(runIfWrong)  # add the loop to the experiment
thisRunIfWrong = runIfWrong.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
if thisRunIfWrong != None:
    for paramName in thisRunIfWrong.keys():
        exec(paramName + '= thisRunIfWrong.' + paramName)

for thisRunIfWrong in runIfWrong:
    currentLoop = runIfWrong
    # abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
    if thisRunIfWrong != None:
        for paramName in thisRunIfWrong.keys():
            exec(paramName + '= thisRunIfWrong.' + paramName)
    
    # ------Prepare to start Routine "ready"-------
    t = 0
    readyClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    clickWhenReady = event.BuilderKeyResponse()
    # keep track of which components have finished
    readyComponents = [areYouReady, clickWhenReady]
    for thisComponent in readyComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "ready"-------
    while continueRoutine:
        # get current time
        t = readyClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *areYouReady* updates
        if t >= 0.0 and areYouReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            areYouReady.tStart = t
            areYouReady.frameNStart = frameN  # exact frame index
            areYouReady.setAutoDraw(True)
        
        # *clickWhenReady* updates
        if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            clickWhenReady.tStart = t
            clickWhenReady.frameNStart = frameN  # exact frame index
            clickWhenReady.status = STARTED
            # keyboard checking is just starting
        if clickWhenReady.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in readyComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ready"-------
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "ready" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    
    # -------2.0 sec delay before showing numbers-------
    blnk = visual.TextStim(win, text=u"    ")
    blnk.draw()
    win.flip()
    core.wait(0.5)
    
    # set up handler to look after randomisation of conditions etc
    numbers22 = data.TrialHandler(nReps=1, method='sequential',
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1'),
        seed=None, name='numbers22')
    thisExp.addLoop(numbers22)  # add the loop to the experiment
    thisNumbers22 = numbers22.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers22.rgb)
    if thisNumbers22 != None:
        for paramName in thisNumbers22.keys():
            exec(paramName + '= thisNumbers22.' + paramName)
    
    for thisNumbers22 in numbers22:
        currentLoop = numbers22
        # abbreviate parameter names if possible (e.g. rgb = thisNumbers22.rgb)
        if thisNumbers22 != None:
            for paramName in thisNumbers22.keys():
                exec(paramName + '= thisNumbers22.' + paramName)
        
        # ------Prepare to start Routine "two2"-------
        t = 0
        two2Clock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(2.000000)
        # update component parameters for each repeat
        two2dig.setText(int(S22))
        # keep track of which components have finished
        two2Components = [two2dig]
        for thisComponent in two2Components:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "two2"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = two2Clock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *two2dig* updates
            if t >= 0.0 and two2dig.status == NOT_STARTED:
                # keep track of start time/frame for later
                two2dig.tStart = t
                two2dig.frameNStart = frameN  # exact frame index
                two2dig.setAutoDraw(True)
            frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if two2dig.status == STARTED and t >= frameRemains:
                two2dig.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in two2Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "two2"-------
        for thisComponent in two2Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'numbers22'
    
    
    # ------Prepare to start Routine "wait"-------
    t = 0
    waitClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    subResp = event.BuilderKeyResponse()
    # keep track of which components have finished
    waitComponents = [qMark, subResp]
    for thisComponent in waitComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "wait"-------
    while continueRoutine:
        # get current time
        t = waitClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *qMark* updates
        if t >= 0.0 and qMark.status == NOT_STARTED:
            # keep track of start time/frame for later
            qMark.tStart = t
            qMark.frameNStart = frameN  # exact frame index
            qMark.setAutoDraw(True)
        
        # *subResp* updates
        if t >= 0.0 and subResp.status == NOT_STARTED:
            # keep track of start time/frame for later
            subResp.tStart = t
            subResp.frameNStart = frameN  # exact frame index
            subResp.status = STARTED
            # keyboard checking is just starting
            subResp.clock.reset()  # now t=0
        if subResp.status == STARTED:
            theseKeys = event.getKeys(keyList=['0', '1'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                subResp.keys = theseKeys[-1]  # just the last key pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in waitComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "wait"-------
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if subResp.keys in ['', [], None]:  # No response was made
        subResp.keys=None
    if subResp.keys == '0': # if subject got it wrong
        incorrect = 1 # set 'incorrect' to 1 so we know to run "endIfWrong" loop and end expt
    elif subResp.keys == '1':
        incorrect = 0
        scoreList.append(1)
        thisExp.addData('setScore',1)

    # the Routine "wait" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    endIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='endIfWrong')
    thisExp.addLoop(endIfWrong)  # add the loop to the experiment
    thisEndIfWrong = endIfWrong.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
    if thisEndIfWrong != None:
        for paramName in thisEndIfWrong.keys():
            exec(paramName + '= thisEndIfWrong.' + paramName)
    
    for thisEndIfWrong in endIfWrong:
        currentLoop = endIfWrong
        # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
        if thisEndIfWrong != None:
            for paramName in thisEndIfWrong.keys():
                exec(paramName + '= thisEndIfWrong.' + paramName)
        
        # ------Prepare to start Routine "endTest"-------
        t = 0
        endTestClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(5.000000)
        # update component parameters for each repeat
        # keep track of which components have finished
        endTestComponents = [goodJobEndTest]
        for thisComponent in endTestComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "endTest"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = endTestClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *goodJobEndTest* updates
            if t >= 0.0 and goodJobEndTest.status == NOT_STARTED:
                # keep track of start time/frame for later
                goodJobEndTest.tStart = t
                goodJobEndTest.frameNStart = frameN  # exact frame index
                goodJobEndTest.setAutoDraw(True)
            frameRemains = 0.0 + 5.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if goodJobEndTest.status == STARTED and t >= frameRemains:
                goodJobEndTest.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in endTestComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "endTest"-------
        for thisComponent in endTestComponents:
            if incorrect == 1:
                endExpNow = True #subject got two lists of this length wrong
                print "Score for ",expInfo['participant']," is ",sum(scoreList[2:-1])+scoreList[-1]
                print "scoreList: ",scoreList
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
                
    # completed subResp repeats of 'endIfWrong'
    
# completed subResp repeats of 'runIfWrong'


# ********************************START THREE SET**************************************
# ------Prepare to start Routine "ready"-------
t = 0
readyClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
clickWhenReady = event.BuilderKeyResponse()
# keep track of which components have finished
readyComponents = [areYouReady, clickWhenReady]
for thisComponent in readyComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "ready"-------
while continueRoutine:
    # get current time
    t = readyClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *areYouReady* updates
    if t >= 0.0 and areYouReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        areYouReady.tStart = t
        areYouReady.frameNStart = frameN  # exact frame index
        areYouReady.setAutoDraw(True)
    
    # *clickWhenReady* updates
    if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        clickWhenReady.tStart = t
        clickWhenReady.frameNStart = frameN  # exact frame index
        clickWhenReady.status = STARTED
        # keyboard checking is just starting
    if clickWhenReady.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ready"-------
for thisComponent in readyComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ready" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# -------2.0 sec delay before showing numbers-------
blnk = visual.TextStim(win, text=u"    ")
blnk.draw()
win.flip()
core.wait(0.5)

# set up handler to look after randomisation of conditions etc
numbers31 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2'),
    seed=None, name='numbers31')
thisExp.addLoop(numbers31)  # add the loop to the experiment
thisNumbers31 = numbers31.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisNumbers31.rgb)
if thisNumbers31 != None:
    for paramName in thisNumbers31.keys():
        exec(paramName + '= thisNumbers31.' + paramName)

for thisNumbers31 in numbers31:
    currentLoop = numbers31
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers31.rgb)
    if thisNumbers31 != None:
        for paramName in thisNumbers31.keys():
            exec(paramName + '= thisNumbers31.' + paramName)
    
    # ------Prepare to start Routine "three1"-------
    t = 0
    three1Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(2.000000)
    # update component parameters for each repeat *****CHANGE HERE FOR NEW SET NUMBER *****
    three1dig.setText(int(S31))
    # keep track of which components have finished
    three1Components = [three1dig]
    for thisComponent in three1Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "three1"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = three1Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text* updates
        if t >= 0.0 and three1dig.status == NOT_STARTED:
            # keep track of start time/frame for later
            three1dig.tStart = t
            three1dig.frameNStart = frameN  # exact frame index
            three1dig.setAutoDraw(True)
        frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if three1dig.status == STARTED and t >= frameRemains:
            three1dig.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in three1Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "three1"-------
    for thisComponent in three1Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
# completed 1 repeats of 'numbers31'


# ------Prepare to start Routine "wait"-------
t = 0
waitClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
subResp = event.BuilderKeyResponse()
# keep track of which components have finished
waitComponents = [qMark, subResp]
for thisComponent in waitComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "wait"-------
while continueRoutine:
    # get current time
    t = waitClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *qMark* updates
    if t >= 0.0 and qMark.status == NOT_STARTED:
        # keep track of start time/frame for later
        qMark.tStart = t
        qMark.frameNStart = frameN  # exact frame index
        qMark.setAutoDraw(True)
    
    # *subResp* updates
    if t >= 0.0 and subResp.status == NOT_STARTED:
        # keep track of start time/frame for later
        subResp.tStart = t
        subResp.frameNStart = frameN  # exact frame index
        subResp.status = STARTED
        # keyboard checking is just starting
        subResp.clock.reset()  # now t=0
    if subResp.status == STARTED:
        theseKeys = event.getKeys(keyList=['0', '1'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            subResp.keys = theseKeys[-1]  # just the last key pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "wait"-------
for thisComponent in waitComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if subResp.keys in ['', [], None]:  # No response was made
    subResp.keys=None


if subResp.keys == '0': 
    incorrect = 1
elif subResp.keys == '1': 
    incorrect = 0
    scoreList.append(2)
    thisExp.addData('setScore',2)

thisExp.nextEntry()
# the Routine "wait" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
runIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='runIfWrong')
thisExp.addLoop(runIfWrong)  # add the loop to the experiment
thisRunIfWrong = runIfWrong.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
if thisRunIfWrong != None:
    for paramName in thisRunIfWrong.keys():
        exec(paramName + '= thisRunIfWrong.' + paramName)

for thisRunIfWrong in runIfWrong:
    currentLoop = runIfWrong
    # abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
    if thisRunIfWrong != None:
        for paramName in thisRunIfWrong.keys():
            exec(paramName + '= thisRunIfWrong.' + paramName)
    
    # ------Prepare to start Routine "ready"-------
    t = 0
    readyClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    clickWhenReady = event.BuilderKeyResponse()
    # keep track of which components have finished
    readyComponents = [areYouReady, clickWhenReady]
    for thisComponent in readyComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "ready"-------
    while continueRoutine:
        # get current time
        t = readyClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *areYouReady* updates
        if t >= 0.0 and areYouReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            areYouReady.tStart = t
            areYouReady.frameNStart = frameN  # exact frame index
            areYouReady.setAutoDraw(True)
        
        # *clickWhenReady* updates
        if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            clickWhenReady.tStart = t
            clickWhenReady.frameNStart = frameN  # exact frame index
            clickWhenReady.status = STARTED
            # keyboard checking is just starting
        if clickWhenReady.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in readyComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ready"-------
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "ready" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    
    # -------2.0 sec delay before showing numbers-------
    blnk = visual.TextStim(win, text=u"    ")
    blnk.draw()
    win.flip()
    core.wait(0.5)
    
    # set up handler to look after randomisation of conditions etc
    numbers32 = data.TrialHandler(nReps=1, method='sequential',
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2'),
        seed=None, name='numbers32')
    thisExp.addLoop(numbers32)  # add the loop to the experiment
    thisNumbers32 = numbers32.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers32.rgb)
    if thisNumbers32 != None:
        for paramName in thisNumbers32.keys():
            exec(paramName + '= thisNumbers32.' + paramName)
    
    for thisNumbers32 in numbers32:
        currentLoop = numbers32
        # abbreviate parameter names if possible (e.g. rgb = thisNumbers32.rgb)
        if thisNumbers32 != None:
            for paramName in thisNumbers32.keys():
                exec(paramName + '= thisNumbers32.' + paramName)
        
        # ------Prepare to start Routine "three2"-------
        t = 0
        three2Clock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(2.000000)
        # update component parameters for each repeat
        three2dig.setText(int(S32))
        # keep track of which components have finished
        three2Components = [three2dig]
        for thisComponent in three2Components:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "three2"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = three2Clock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *three2dig* updates
            if t >= 0.0 and three2dig.status == NOT_STARTED:
                # keep track of start time/frame for later
                three2dig.tStart = t
                three2dig.frameNStart = frameN  # exact frame index
                three2dig.setAutoDraw(True)
            frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if three2dig.status == STARTED and t >= frameRemains:
                three2dig.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in three2Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "three2"-------
        for thisComponent in three2Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'numbers32'
    
    
    # ------Prepare to start Routine "wait"-------
    t = 0
    waitClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    subResp = event.BuilderKeyResponse()
    # keep track of which components have finished
    waitComponents = [qMark, subResp]
    for thisComponent in waitComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "wait"-------
    while continueRoutine:
        # get current time
        t = waitClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *qMark* updates
        if t >= 0.0 and qMark.status == NOT_STARTED:
            # keep track of start time/frame for later
            qMark.tStart = t
            qMark.frameNStart = frameN  # exact frame index
            qMark.setAutoDraw(True)
        
        # *subResp* updates
        if t >= 0.0 and subResp.status == NOT_STARTED:
            # keep track of start time/frame for later
            subResp.tStart = t
            subResp.frameNStart = frameN  # exact frame index
            subResp.status = STARTED
            # keyboard checking is just starting
            subResp.clock.reset()  # now t=0
        if subResp.status == STARTED:
            theseKeys = event.getKeys(keyList=['0', '1'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                subResp.keys = theseKeys[-1]  # just the last key pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in waitComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "wait"-------
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if subResp.keys in ['', [], None]:  # No response was made
        subResp.keys=None

    if subResp.keys == '0': # if subject got it wrong
        incorrect = 1 # set 'incorrect' to 1 so we know to run "endIfWrong" loop and end expt
    elif subResp.keys == '1':
        incorrect = 0
        scoreList.append(1)
        thisExp.addData('setScore',1)
        
    # the Routine "wait" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    endIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='endIfWrong')
    thisExp.addLoop(endIfWrong)  # add the loop to the experiment
    thisEndIfWrong = endIfWrong.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
    if thisEndIfWrong != None:
        for paramName in thisEndIfWrong.keys():
            exec(paramName + '= thisEndIfWrong.' + paramName)
    
    for thisEndIfWrong in endIfWrong:
        currentLoop = endIfWrong
        # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
        if thisEndIfWrong != None:
            for paramName in thisEndIfWrong.keys():
                exec(paramName + '= thisEndIfWrong.' + paramName)
        
        # ------Prepare to start Routine "endTest"-------
        t = 0
        endTestClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(5.000000)
        # update component parameters for each repeat
        # keep track of which components have finished
        endTestComponents = [goodJobEndTest]
        for thisComponent in endTestComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "endTest"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = endTestClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *goodJobEndTest* updates
            if t >= 0.0 and goodJobEndTest.status == NOT_STARTED:
                # keep track of start time/frame for later
                goodJobEndTest.tStart = t
                goodJobEndTest.frameNStart = frameN  # exact frame index
                goodJobEndTest.setAutoDraw(True)
            frameRemains = 0.0 + 5.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if goodJobEndTest.status == STARTED and t >= frameRemains:
                goodJobEndTest.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in endTestComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "endTest"-------
        for thisComponent in endTestComponents:
            if incorrect == 1:
                endExpNow = True #subject got two lists of this length wrong
                print "Score for ",expInfo['participant']," is ",sum(scoreList[2:-1])+scoreList[-1]
                print "scoreList: ",scoreList
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
                
    # completed subResp repeats of 'endIfWrong'
    
# completed subResp repeats of 'runIfWrong'



# ******************************************START FOUR SET************************************
# ------Prepare to start Routine "ready"-------
t = 0
readyClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
clickWhenReady = event.BuilderKeyResponse()
# keep track of which components have finished
readyComponents = [areYouReady, clickWhenReady]
for thisComponent in readyComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "ready"-------
while continueRoutine:
    # get current time
    t = readyClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *areYouReady* updates
    if t >= 0.0 and areYouReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        areYouReady.tStart = t
        areYouReady.frameNStart = frameN  # exact frame index
        areYouReady.setAutoDraw(True)
    
    # *clickWhenReady* updates
    if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        clickWhenReady.tStart = t
        clickWhenReady.frameNStart = frameN  # exact frame index
        clickWhenReady.status = STARTED
        # keyboard checking is just starting
    if clickWhenReady.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ready"-------
for thisComponent in readyComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ready" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# -------2.0 sec delay before showing numbers-------
blnk = visual.TextStim(win, text=u"    ")
blnk.draw()
win.flip()
core.wait(0.5)

# set up handler to look after randomisation of conditions etc
numbers41 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2,3'),
    seed=None, name='numbers41')
thisExp.addLoop(numbers41)  # add the loop to the experiment
thisNumbers41 = numbers41.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisNumbers21.rgb)
if thisNumbers41 != None:
    for paramName in thisNumbers41.keys():
        exec(paramName + '= thisNumbers41.' + paramName)

for thisNumbers41 in numbers41:
    currentLoop = numbers41
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers21.rgb)
    if thisNumbers41 != None:
        for paramName in thisNumbers41.keys():
            exec(paramName + '= thisNumbers41.' + paramName)
    
    # ------Prepare to start Routine "four1"-------
    t = 0
    four1Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(2.000000)
    # update component parameters for each repeat *****CHANGE HERE FOR NEW SET NUMBER *****
    four1dig.setText(int(S41))
    # keep track of which components have finished
    four1Components = [four1dig]
    for thisComponent in four1Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "four1"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = four1Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text* updates
        if t >= 0.0 and four1dig.status == NOT_STARTED:
            # keep track of start time/frame for later
            four1dig.tStart = t
            four1dig.frameNStart = frameN  # exact frame index
            four1dig.setAutoDraw(True)
        frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if four1dig.status == STARTED and t >= frameRemains:
            four1dig.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in four1Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "four1"-------
    for thisComponent in four1Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
# completed 1 repeats of 'numbers41'


# ------Prepare to start Routine "wait"-------
t = 0
waitClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
subResp = event.BuilderKeyResponse()
# keep track of which components have finished
waitComponents = [qMark, subResp]
for thisComponent in waitComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "wait"-------
while continueRoutine:
    # get current time
    t = waitClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *qMark* updates
    if t >= 0.0 and qMark.status == NOT_STARTED:
        # keep track of start time/frame for later
        qMark.tStart = t
        qMark.frameNStart = frameN  # exact frame index
        qMark.setAutoDraw(True)
    
    # *subResp* updates
    if t >= 0.0 and subResp.status == NOT_STARTED:
        # keep track of start time/frame for later
        subResp.tStart = t
        subResp.frameNStart = frameN  # exact frame index
        subResp.status = STARTED
        # keyboard checking is just starting
        subResp.clock.reset()  # now t=0
    if subResp.status == STARTED:
        theseKeys = event.getKeys(keyList=['0', '1'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            subResp.keys = theseKeys[-1]  # just the last key pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "wait"-------
for thisComponent in waitComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if subResp.keys in ['', [], None]:  # No response was made
    subResp.keys=None


if subResp.keys == '0': 
    incorrect = 1
elif subResp.keys == '1':
    incorrect = 0
    scoreList.append(2)
    thisExp.addData('setScore',2)

thisExp.nextEntry()
# the Routine "wait" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
runIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='runIfWrong')
thisExp.addLoop(runIfWrong)  # add the loop to the experiment
thisRunIfWrong = runIfWrong.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
if thisRunIfWrong != None:
    for paramName in thisRunIfWrong.keys():
        exec(paramName + '= thisRunIfWrong.' + paramName)

for thisRunIfWrong in runIfWrong:
    currentLoop = runIfWrong
    # abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
    if thisRunIfWrong != None:
        for paramName in thisRunIfWrong.keys():
            exec(paramName + '= thisRunIfWrong.' + paramName)
    
    # ------Prepare to start Routine "ready"-------
    t = 0
    readyClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    clickWhenReady = event.BuilderKeyResponse()
    # keep track of which components have finished
    readyComponents = [areYouReady, clickWhenReady]
    for thisComponent in readyComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "ready"-------
    while continueRoutine:
        # get current time
        t = readyClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *areYouReady* updates
        if t >= 0.0 and areYouReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            areYouReady.tStart = t
            areYouReady.frameNStart = frameN  # exact frame index
            areYouReady.setAutoDraw(True)
        
        # *clickWhenReady* updates
        if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            clickWhenReady.tStart = t
            clickWhenReady.frameNStart = frameN  # exact frame index
            clickWhenReady.status = STARTED
            # keyboard checking is just starting
        if clickWhenReady.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in readyComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ready"-------
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "ready" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    
    # -------2.0 sec delay before showing numbers-------
    blnk = visual.TextStim(win, text=u"    ")
    blnk.draw()
    win.flip()
    core.wait(0.5)
    
    # set up handler to look after randomisation of conditions etc
    numbers42 = data.TrialHandler(nReps=1, method='sequential',
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2,3'),
        seed=None, name='numbers42')
    thisExp.addLoop(numbers42)  # add the loop to the experiment
    thisNumbers42 = numbers42.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers42.rgb)
    if thisNumbers42 != None:
        for paramName in thisNumbers42.keys():
            exec(paramName + '= thisNumbers42.' + paramName)
    
    for thisNumbers42 in numbers42:
        currentLoop = numbers42
        # abbreviate parameter names if possible (e.g. rgb = thisNumbers42.rgb)
        if thisNumbers42 != None:
            for paramName in thisNumbers42.keys():
                exec(paramName + '= thisNumbers42.' + paramName)
        
        # ------Prepare to start Routine "four2"-------
        t = 0
        four2Clock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(2.000000)
        # update component parameters for each repeat
        four2dig.setText(int(S42))
        # keep track of which components have finished
        four2Components = [four2dig]
        for thisComponent in four2Components:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "four2"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = four2Clock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *four2dig* updates
            if t >= 0.0 and four2dig.status == NOT_STARTED:
                # keep track of start time/frame for later
                four2dig.tStart = t
                four2dig.frameNStart = frameN  # exact frame index
                four2dig.setAutoDraw(True)
            frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if four2dig.status == STARTED and t >= frameRemains:
                four2dig.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in four2Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "four2"-------
        for thisComponent in four2Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'numbers42'
    
    
    # ------Prepare to start Routine "wait"-------
    t = 0
    waitClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    subResp = event.BuilderKeyResponse()
    # keep track of which components have finished
    waitComponents = [qMark, subResp]
    for thisComponent in waitComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "wait"-------
    while continueRoutine:
        # get current time
        t = waitClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *qMark* updates
        if t >= 0.0 and qMark.status == NOT_STARTED:
            # keep track of start time/frame for later
            qMark.tStart = t
            qMark.frameNStart = frameN  # exact frame index
            qMark.setAutoDraw(True)
        
        # *subResp* updates
        if t >= 0.0 and subResp.status == NOT_STARTED:
            # keep track of start time/frame for later
            subResp.tStart = t
            subResp.frameNStart = frameN  # exact frame index
            subResp.status = STARTED
            # keyboard checking is just starting
            subResp.clock.reset()  # now t=0
        if subResp.status == STARTED:
            theseKeys = event.getKeys(keyList=['0', '1'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                subResp.keys = theseKeys[-1]  # just the last key pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in waitComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "wait"-------
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if subResp.keys in ['', [], None]:  # No response was made
        subResp.keys=None

    if subResp.keys == '0': # if subject got it wrong
        incorrect = 1 # set 'incorrect' to 1 so we know to run "endIfWrong" loop and end expt
    elif subResp.keys == '1':
        incorrect = 0
        scoreList.append(1)
        thisExp.addData('setScore',1)
        
    # the Routine "wait" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    endIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='endIfWrong')
    thisExp.addLoop(endIfWrong)  # add the loop to the experiment
    thisEndIfWrong = endIfWrong.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
    if thisEndIfWrong != None:
        for paramName in thisEndIfWrong.keys():
            exec(paramName + '= thisEndIfWrong.' + paramName)
    
    for thisEndIfWrong in endIfWrong:
        currentLoop = endIfWrong
        # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
        if thisEndIfWrong != None:
            for paramName in thisEndIfWrong.keys():
                exec(paramName + '= thisEndIfWrong.' + paramName)
        
        # ------Prepare to start Routine "endTest"-------
        t = 0
        endTestClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(5.000000)
        # update component parameters for each repeat
        # keep track of which components have finished
        endTestComponents = [goodJobEndTest]
        for thisComponent in endTestComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "endTest"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = endTestClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *goodJobEndTest* updates
            if t >= 0.0 and goodJobEndTest.status == NOT_STARTED:
                # keep track of start time/frame for later
                goodJobEndTest.tStart = t
                goodJobEndTest.frameNStart = frameN  # exact frame index
                goodJobEndTest.setAutoDraw(True)
            frameRemains = 0.0 + 5.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if goodJobEndTest.status == STARTED and t >= frameRemains:
                goodJobEndTest.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in endTestComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "endTest"-------
        for thisComponent in endTestComponents:
            if incorrect == 1:
                endExpNow = True #subject got two lists of this length wrong
                print "Score for ",expInfo['participant']," is ",sum(scoreList[2:-1])+scoreList[-1]
                print "scoreList: ",scoreList
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
                
    # completed subResp repeats of 'endIfWrong'
    
# completed subResp repeats of 'runIfWrong'


# ******************************************START FIVE SET************************************
# ------Prepare to start Routine "ready"-------
t = 0
readyClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
clickWhenReady = event.BuilderKeyResponse()
# keep track of which components have finished
readyComponents = [areYouReady, clickWhenReady]
for thisComponent in readyComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "ready"-------
while continueRoutine:
    # get current time
    t = readyClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *areYouReady* updates
    if t >= 0.0 and areYouReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        areYouReady.tStart = t
        areYouReady.frameNStart = frameN  # exact frame index
        areYouReady.setAutoDraw(True)
    
    # *clickWhenReady* updates
    if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        clickWhenReady.tStart = t
        clickWhenReady.frameNStart = frameN  # exact frame index
        clickWhenReady.status = STARTED
        # keyboard checking is just starting
    if clickWhenReady.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ready"-------
for thisComponent in readyComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ready" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# -------2.0 sec delay before showing numbers-------
blnk = visual.TextStim(win, text=u"    ")
blnk.draw()
win.flip()
core.wait(0.5)

# set up handler to look after randomisation of conditions etc
numbers51 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2,3,4'),
    seed=None, name='numbers51')
thisExp.addLoop(numbers51)  # add the loop to the experiment
thisNumbers51 = numbers51.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisNumbers21.rgb)
if thisNumbers51 != None:
    for paramName in thisNumbers51.keys():
        exec(paramName + '= thisNumbers51.' + paramName)

for thisNumbers51 in numbers51:
    currentLoop = numbers51
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers51.rgb)
    if thisNumbers51 != None:
        for paramName in thisNumbers51.keys():
            exec(paramName + '= thisNumbers51.' + paramName)
    
    # ------Prepare to start Routine "five1"-------
    t = 0
    five1Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(2.000000)
    # update component parameters for each repeat *****CHANGE HERE FOR NEW SET NUMBER *****
    five1dig.setText(int(S51))
    # keep track of which components have finished
    five1Components = [five1dig]
    for thisComponent in five1Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "five1"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = five1Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text* updates
        if t >= 0.0 and five1dig.status == NOT_STARTED:
            # keep track of start time/frame for later
            five1dig.tStart = t
            five1dig.frameNStart = frameN  # exact frame index
            five1dig.setAutoDraw(True)
        frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if five1dig.status == STARTED and t >= frameRemains:
            five1dig.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in five1Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "five1"-------
    for thisComponent in five1Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
# completed 1 repeats of 'numbers51'


# ------Prepare to start Routine "wait"-------
t = 0
waitClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
subResp = event.BuilderKeyResponse()
# keep track of which components have finished
waitComponents = [qMark, subResp]
for thisComponent in waitComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "wait"-------
while continueRoutine:
    # get current time
    t = waitClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *qMark* updates
    if t >= 0.0 and qMark.status == NOT_STARTED:
        # keep track of start time/frame for later
        qMark.tStart = t
        qMark.frameNStart = frameN  # exact frame index
        qMark.setAutoDraw(True)
    
    # *subResp* updates
    if t >= 0.0 and subResp.status == NOT_STARTED:
        # keep track of start time/frame for later
        subResp.tStart = t
        subResp.frameNStart = frameN  # exact frame index
        subResp.status = STARTED
        # keyboard checking is just starting
        subResp.clock.reset()  # now t=0
    if subResp.status == STARTED:
        theseKeys = event.getKeys(keyList=['0', '1'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            subResp.keys = theseKeys[-1]  # just the last key pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "wait"-------
for thisComponent in waitComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if subResp.keys in ['', [], None]:  # No response was made
    subResp.keys=None

if subResp.keys == '0': 
    incorrect = 1
elif subResp.keys == '1': 
    incorrect = 0
    scoreList.append(2)
    thisExp.addData('setScore',2)

thisExp.nextEntry()
# the Routine "wait" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
runIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='runIfWrong')
thisExp.addLoop(runIfWrong)  # add the loop to the experiment
thisRunIfWrong = runIfWrong.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
if thisRunIfWrong != None:
    for paramName in thisRunIfWrong.keys():
        exec(paramName + '= thisRunIfWrong.' + paramName)

for thisRunIfWrong in runIfWrong:
    currentLoop = runIfWrong
    # abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
    if thisRunIfWrong != None:
        for paramName in thisRunIfWrong.keys():
            exec(paramName + '= thisRunIfWrong.' + paramName)
    
    # ------Prepare to start Routine "ready"-------
    t = 0
    readyClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    clickWhenReady = event.BuilderKeyResponse()
    # keep track of which components have finished
    readyComponents = [areYouReady, clickWhenReady]
    for thisComponent in readyComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "ready"-------
    while continueRoutine:
        # get current time
        t = readyClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *areYouReady* updates
        if t >= 0.0 and areYouReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            areYouReady.tStart = t
            areYouReady.frameNStart = frameN  # exact frame index
            areYouReady.setAutoDraw(True)
        
        # *clickWhenReady* updates
        if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            clickWhenReady.tStart = t
            clickWhenReady.frameNStart = frameN  # exact frame index
            clickWhenReady.status = STARTED
            # keyboard checking is just starting
        if clickWhenReady.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in readyComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ready"-------
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "ready" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    
    # -------2.0 sec delay before showing numbers-------
    blnk = visual.TextStim(win, text=u"    ")
    blnk.draw()
    win.flip()
    core.wait(0.5)
    
    # set up handler to look after randomisation of conditions etc
    numbers52 = data.TrialHandler(nReps=1, method='sequential',
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2,3,4'),
        seed=None, name='numbers52')
    thisExp.addLoop(numbers52)  # add the loop to the experiment
    thisNumbers52 = numbers52.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers52.rgb)
    if thisNumbers52 != None:
        for paramName in thisNumbers52.keys():
            exec(paramName + '= thisNumbers52.' + paramName)
    
    for thisNumbers52 in numbers52:
        currentLoop = numbers52
        # abbreviate parameter names if possible (e.g. rgb = thisNumbers52.rgb)
        if thisNumbers52 != None:
            for paramName in thisNumbers52.keys():
                exec(paramName + '= thisNumbers52.' + paramName)
        
        # ------Prepare to start Routine "five2"-------
        t = 0
        five2Clock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(2.000000)
        # update component parameters for each repeat
        five2dig.setText(int(S52))
        # keep track of which components have finished
        five2Components = [five2dig]
        for thisComponent in five2Components:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "five2"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = five2Clock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *five2dig* updates
            if t >= 0.0 and five2dig.status == NOT_STARTED:
                # keep track of start time/frame for later
                five2dig.tStart = t
                five2dig.frameNStart = frameN  # exact frame index
                five2dig.setAutoDraw(True)
            frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if five2dig.status == STARTED and t >= frameRemains:
                five2dig.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in five2Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "five2"-------
        for thisComponent in five2Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'numbers52'
    
    
    # ------Prepare to start Routine "wait"-------
    t = 0
    waitClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    subResp = event.BuilderKeyResponse()
    # keep track of which components have finished
    waitComponents = [qMark, subResp]
    for thisComponent in waitComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "wait"-------
    while continueRoutine:
        # get current time
        t = waitClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *qMark* updates
        if t >= 0.0 and qMark.status == NOT_STARTED:
            # keep track of start time/frame for later
            qMark.tStart = t
            qMark.frameNStart = frameN  # exact frame index
            qMark.setAutoDraw(True)
        
        # *subResp* updates
        if t >= 0.0 and subResp.status == NOT_STARTED:
            # keep track of start time/frame for later
            subResp.tStart = t
            subResp.frameNStart = frameN  # exact frame index
            subResp.status = STARTED
            # keyboard checking is just starting
            subResp.clock.reset()  # now t=0
        if subResp.status == STARTED:
            theseKeys = event.getKeys(keyList=['0', '1'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                subResp.keys = theseKeys[-1]  # just the last key pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in waitComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "wait"-------
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if subResp.keys in ['', [], None]:  # No response was made
        subResp.keys=None

    if subResp.keys == '0': # if subject got it wrong
        incorrect = 1 # set 'incorrect' to 1 so we know to run "endIfWrong" loop and end expt
    elif subResp.keys == '1':
        incorrect = 0
        scoreList.append(1)
        thisExp.addData('setScore',1)
    # the Routine "wait" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    endIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='endIfWrong')
    thisExp.addLoop(endIfWrong)  # add the loop to the experiment
    thisEndIfWrong = endIfWrong.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
    if thisEndIfWrong != None:
        for paramName in thisEndIfWrong.keys():
            exec(paramName + '= thisEndIfWrong.' + paramName)
    
    for thisEndIfWrong in endIfWrong:
        currentLoop = endIfWrong
        # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
        if thisEndIfWrong != None:
            for paramName in thisEndIfWrong.keys():
                exec(paramName + '= thisEndIfWrong.' + paramName)
        
        # ------Prepare to start Routine "endTest"-------
        t = 0
        endTestClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(5.000000)
        # update component parameters for each repeat
        # keep track of which components have finished
        endTestComponents = [goodJobEndTest]
        for thisComponent in endTestComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "endTest"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = endTestClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *goodJobEndTest* updates
            if t >= 0.0 and goodJobEndTest.status == NOT_STARTED:
                # keep track of start time/frame for later
                goodJobEndTest.tStart = t
                goodJobEndTest.frameNStart = frameN  # exact frame index
                goodJobEndTest.setAutoDraw(True)
            frameRemains = 0.0 + 5.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if goodJobEndTest.status == STARTED and t >= frameRemains:
                goodJobEndTest.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in endTestComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "endTest"-------
        for thisComponent in endTestComponents:
            if incorrect == 1:
                endExpNow = True #subject got two lists of this length wrong
                print "Score for ",expInfo['participant']," is ",sum(scoreList[2:-1])+scoreList[-1]
                print "scoreList: ",scoreList
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
                
    # completed subResp repeats of 'endIfWrong'
    
# completed subResp repeats of 'runIfWrong'


# ******************************************START SIX SET************************************
# ------Prepare to start Routine "ready"-------
t = 0
readyClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
clickWhenReady = event.BuilderKeyResponse()
# keep track of which components have finished
readyComponents = [areYouReady, clickWhenReady]
for thisComponent in readyComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "ready"-------
while continueRoutine:
    # get current time
    t = readyClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *areYouReady* updates
    if t >= 0.0 and areYouReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        areYouReady.tStart = t
        areYouReady.frameNStart = frameN  # exact frame index
        areYouReady.setAutoDraw(True)
    
    # *clickWhenReady* updates
    if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        clickWhenReady.tStart = t
        clickWhenReady.frameNStart = frameN  # exact frame index
        clickWhenReady.status = STARTED
        # keyboard checking is just starting
    if clickWhenReady.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ready"-------
for thisComponent in readyComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ready" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# -------2.0 sec delay before showing numbers-------
blnk = visual.TextStim(win, text=u"    ")
blnk.draw()
win.flip()
core.wait(0.5)

# set up handler to look after randomisation of conditions etc
numbers61 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2,3,4,5'),
    seed=None, name='numbers61')
thisExp.addLoop(numbers61)  # add the loop to the experiment
thisNumbers61 = numbers61.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisNumbers61.rgb)
if thisNumbers61 != None:
    for paramName in thisNumbers61.keys():
        exec(paramName + '= thisNumbers61.' + paramName)

for thisNumbers61 in numbers61:
    currentLoop = numbers61
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers61.rgb)
    if thisNumbers61 != None:
        for paramName in thisNumbers61.keys():
            exec(paramName + '= thisNumbers61.' + paramName)
    
    # ------Prepare to start Routine "six1"-------
    t = 0
    six1Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(2.000000)
    # update component parameters for each repeat *****CHANGE HERE FOR NEW SET NUMBER *****
    six1dig.setText(int(S61))
    # keep track of which components have finished
    six1Components = [six1dig]
    for thisComponent in six1Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "six1"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = six1Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text* updates
        if t >= 0.0 and six1dig.status == NOT_STARTED:
            # keep track of start time/frame for later
            six1dig.tStart = t
            six1dig.frameNStart = frameN  # exact frame index
            six1dig.setAutoDraw(True)
        frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if six1dig.status == STARTED and t >= frameRemains:
            six1dig.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in six1Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "six1"-------
    for thisComponent in six1Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
# completed 1 repeats of 'numbers61'


# ------Prepare to start Routine "wait"-------
t = 0
waitClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
subResp = event.BuilderKeyResponse()
# keep track of which components have finished
waitComponents = [qMark, subResp]
for thisComponent in waitComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "wait"-------
while continueRoutine:
    # get current time
    t = waitClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *qMark* updates
    if t >= 0.0 and qMark.status == NOT_STARTED:
        # keep track of start time/frame for later
        qMark.tStart = t
        qMark.frameNStart = frameN  # exact frame index
        qMark.setAutoDraw(True)
    
    # *subResp* updates
    if t >= 0.0 and subResp.status == NOT_STARTED:
        # keep track of start time/frame for later
        subResp.tStart = t
        subResp.frameNStart = frameN  # exact frame index
        subResp.status = STARTED
        # keyboard checking is just starting
        subResp.clock.reset()  # now t=0
    if subResp.status == STARTED:
        theseKeys = event.getKeys(keyList=['0', '1'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            subResp.keys = theseKeys[-1]  # just the last key pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "wait"-------
for thisComponent in waitComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if subResp.keys in ['', [], None]:  # No response was made
    subResp.keys=None

if subResp.keys == '0': 
    incorrect = 1
elif subResp.keys == '1': 
    incorrect = 0
    scoreList.append(2)
    thisExp.addData('setScore',2)

thisExp.nextEntry()
# the Routine "wait" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
runIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='runIfWrong')
thisExp.addLoop(runIfWrong)  # add the loop to the experiment
thisRunIfWrong = runIfWrong.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
if thisRunIfWrong != None:
    for paramName in thisRunIfWrong.keys():
        exec(paramName + '= thisRunIfWrong.' + paramName)

for thisRunIfWrong in runIfWrong:
    currentLoop = runIfWrong
    # abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
    if thisRunIfWrong != None:
        for paramName in thisRunIfWrong.keys():
            exec(paramName + '= thisRunIfWrong.' + paramName)
    
    # ------Prepare to start Routine "ready"-------
    t = 0
    readyClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    clickWhenReady = event.BuilderKeyResponse()
    # keep track of which components have finished
    readyComponents = [areYouReady, clickWhenReady]
    for thisComponent in readyComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "ready"-------
    while continueRoutine:
        # get current time
        t = readyClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *areYouReady* updates
        if t >= 0.0 and areYouReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            areYouReady.tStart = t
            areYouReady.frameNStart = frameN  # exact frame index
            areYouReady.setAutoDraw(True)
        
        # *clickWhenReady* updates
        if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            clickWhenReady.tStart = t
            clickWhenReady.frameNStart = frameN  # exact frame index
            clickWhenReady.status = STARTED
            # keyboard checking is just starting
        if clickWhenReady.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in readyComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ready"-------
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "ready" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    
    # -------2.0 sec delay before showing numbers-------
    blnk = visual.TextStim(win, text=u"    ")
    blnk.draw()
    win.flip()
    core.wait(0.5)
    
    # set up handler to look after randomisation of conditions etc
    numbers62 = data.TrialHandler(nReps=1, method='sequential',
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2,3,4,5'),
        seed=None, name='numbers62')
    thisExp.addLoop(numbers62)  # add the loop to the experiment
    thisNumbers62 = numbers62.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers62.rgb)
    if thisNumbers62 != None:
        for paramName in thisNumbers62.keys():
            exec(paramName + '= thisNumbers62.' + paramName)
    
    for thisNumbers62 in numbers62:
        currentLoop = numbers62
        # abbreviate parameter names if possible (e.g. rgb = thisNumbers62.rgb)
        if thisNumbers62 != None:
            for paramName in thisNumbers62.keys():
                exec(paramName + '= thisNumbers62.' + paramName)
        
        # ------Prepare to start Routine "six2"-------
        t = 0
        six2Clock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(2.000000)
        # update component parameters for each repeat
        six2dig.setText(int(S62))
        # keep track of which components have finished
        six2Components = [six2dig]
        for thisComponent in six2Components:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "six2"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = six2Clock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *six2dig* updates
            if t >= 0.0 and six2dig.status == NOT_STARTED:
                # keep track of start time/frame for later
                six2dig.tStart = t
                six2dig.frameNStart = frameN  # exact frame index
                six2dig.setAutoDraw(True)
            frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if six2dig.status == STARTED and t >= frameRemains:
                six2dig.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in six2Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "six2"-------
        for thisComponent in six2Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'numbers62'
    
    
    # ------Prepare to start Routine "wait"-------
    t = 0
    waitClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    subResp = event.BuilderKeyResponse()
    # keep track of which components have finished
    waitComponents = [qMark, subResp]
    for thisComponent in waitComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "wait"-------
    while continueRoutine:
        # get current time
        t = waitClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *qMark* updates
        if t >= 0.0 and qMark.status == NOT_STARTED:
            # keep track of start time/frame for later
            qMark.tStart = t
            qMark.frameNStart = frameN  # exact frame index
            qMark.setAutoDraw(True)
        
        # *subResp* updates
        if t >= 0.0 and subResp.status == NOT_STARTED:
            # keep track of start time/frame for later
            subResp.tStart = t
            subResp.frameNStart = frameN  # exact frame index
            subResp.status = STARTED
            # keyboard checking is just starting
            subResp.clock.reset()  # now t=0
        if subResp.status == STARTED:
            theseKeys = event.getKeys(keyList=['0', '1'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                subResp.keys = theseKeys[-1]  # just the last key pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in waitComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "wait"-------
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if subResp.keys in ['', [], None]:  # No response was made
        subResp.keys=None
    else:
        if subResp.keys == '0': # if subject got it wrong
            incorrect = 1 # set 'incorrect' to 1 so we know to run "endIfWrong" loop and end expt
        elif subResp.keys == '1':
            incorrect = 0
            scoreList.append(1)
            thisExp.addData('setScore',1)
        
    # the Routine "wait" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    endIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='endIfWrong')
    thisExp.addLoop(endIfWrong)  # add the loop to the experiment
    thisEndIfWrong = endIfWrong.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
    if thisEndIfWrong != None:
        for paramName in thisEndIfWrong.keys():
            exec(paramName + '= thisEndIfWrong.' + paramName)
    
    for thisEndIfWrong in endIfWrong:
        currentLoop = endIfWrong
        # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
        if thisEndIfWrong != None:
            for paramName in thisEndIfWrong.keys():
                exec(paramName + '= thisEndIfWrong.' + paramName)
        
        # ------Prepare to start Routine "endTest"-------
        t = 0
        endTestClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(5.000000)
        # update component parameters for each repeat
        # keep track of which components have finished
        endTestComponents = [goodJobEndTest]
        for thisComponent in endTestComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "endTest"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = endTestClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *goodJobEndTest* updates
            if t >= 0.0 and goodJobEndTest.status == NOT_STARTED:
                # keep track of start time/frame for later
                goodJobEndTest.tStart = t
                goodJobEndTest.frameNStart = frameN  # exact frame index
                goodJobEndTest.setAutoDraw(True)
            frameRemains = 0.0 + 5.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if goodJobEndTest.status == STARTED and t >= frameRemains:
                goodJobEndTest.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in endTestComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "endTest"-------
        for thisComponent in endTestComponents:
            if incorrect == 1:
                endExpNow = True #subject got two lists of this length wrong
                print "Score for ",expInfo['participant']," is ",sum(scoreList[2:-1])+scoreList[-1]
                print "scoreList: ",scoreList
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
                
    # completed subResp repeats of 'endIfWrong'
    
# completed subResp repeats of 'runIfWrong'

# ******************************************START SEVEN SET************************************
# ------Prepare to start Routine "ready"-------
t = 0
readyClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
clickWhenReady = event.BuilderKeyResponse()
# keep track of which components have finished
readyComponents = [areYouReady, clickWhenReady]
for thisComponent in readyComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "ready"-------
while continueRoutine:
    # get current time
    t = readyClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *areYouReady* updates
    if t >= 0.0 and areYouReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        areYouReady.tStart = t
        areYouReady.frameNStart = frameN  # exact frame index
        areYouReady.setAutoDraw(True)
    
    # *clickWhenReady* updates
    if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
        # keep track of start time/frame for later
        clickWhenReady.tStart = t
        clickWhenReady.frameNStart = frameN  # exact frame index
        clickWhenReady.status = STARTED
        # keyboard checking is just starting
    if clickWhenReady.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ready"-------
for thisComponent in readyComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ready" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# -------2.0 sec delay before showing numbers-------
blnk = visual.TextStim(win, text=u"    ")
blnk.draw()
win.flip()
core.wait(0.5)

# set up handler to look after randomisation of conditions etc
numbers71 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2,3,4,5,6'),
    seed=None, name='numbers71')
thisExp.addLoop(numbers71)  # add the loop to the experiment
thisNumbers71 = numbers71.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisNumbers71.rgb)
if thisNumbers71 != None:
    for paramName in thisNumbers71.keys():
        exec(paramName + '= thisNumbers71.' + paramName)

for thisNumbers71 in numbers71:
    currentLoop = numbers71
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers71.rgb)
    if thisNumbers71 != None:
        for paramName in thisNumbers71.keys():
            exec(paramName + '= thisNumbers71.' + paramName)
    
    # ------Prepare to start Routine "seven1"-------
    t = 0
    seven1Clock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(2.000000)
    # update component parameters for each repeat *****CHANGE HERE FOR NEW SET NUMBER *****
    seven1dig.setText(int(S71))
    # keep track of which components have finished
    seven1Components = [seven1dig]
    for thisComponent in seven1Components:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "seven1"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = seven1Clock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text* updates
        if t >= 0.0 and seven1dig.status == NOT_STARTED:
            # keep track of start time/frame for later
            seven1dig.tStart = t
            seven1dig.frameNStart = frameN  # exact frame index
            seven1dig.setAutoDraw(True)
        frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
        if seven1dig.status == STARTED and t >= frameRemains:
            seven1dig.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in seven1Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "five1"-------
    for thisComponent in seven1Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
# completed 1 repeats of 'numbers71'


# ------Prepare to start Routine "wait"-------
t = 0
waitClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
subResp = event.BuilderKeyResponse()
# keep track of which components have finished
waitComponents = [qMark, subResp]
for thisComponent in waitComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "wait"-------
while continueRoutine:
    # get current time
    t = waitClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *qMark* updates
    if t >= 0.0 and qMark.status == NOT_STARTED:
        # keep track of start time/frame for later
        qMark.tStart = t
        qMark.frameNStart = frameN  # exact frame index
        qMark.setAutoDraw(True)
    
    # *subResp* updates
    if t >= 0.0 and subResp.status == NOT_STARTED:
        # keep track of start time/frame for later
        subResp.tStart = t
        subResp.frameNStart = frameN  # exact frame index
        subResp.status = STARTED
        # keyboard checking is just starting
        subResp.clock.reset()  # now t=0
    if subResp.status == STARTED:
        theseKeys = event.getKeys(keyList=['0', '1'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            subResp.keys = theseKeys[-1]  # just the last key pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "wait"-------
for thisComponent in waitComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if subResp.keys in ['', [], None]:  # No response was made
    subResp.keys=None


if subResp.keys == '0': 
    incorrect = 1
else: 
    incorrect = 0
    scoreList.append(2)
    thisExp.addData('setScore',2)
thisExp.nextEntry()
# the Routine "wait" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
runIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='runIfWrong')
thisExp.addLoop(runIfWrong)  # add the loop to the experiment
thisRunIfWrong = runIfWrong.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
if thisRunIfWrong != None:
    for paramName in thisRunIfWrong.keys():
        exec(paramName + '= thisRunIfWrong.' + paramName)

for thisRunIfWrong in runIfWrong:
    currentLoop = runIfWrong
    # abbreviate parameter names if possible (e.g. rgb = thisRunIfWrong.rgb)
    if thisRunIfWrong != None:
        for paramName in thisRunIfWrong.keys():
            exec(paramName + '= thisRunIfWrong.' + paramName)
    
    # ------Prepare to start Routine "ready"-------
    t = 0
    readyClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    clickWhenReady = event.BuilderKeyResponse()
    # keep track of which components have finished
    readyComponents = [areYouReady, clickWhenReady]
    for thisComponent in readyComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "ready"-------
    while continueRoutine:
        # get current time
        t = readyClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *areYouReady* updates
        if t >= 0.0 and areYouReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            areYouReady.tStart = t
            areYouReady.frameNStart = frameN  # exact frame index
            areYouReady.setAutoDraw(True)
        
        # *clickWhenReady* updates
        if t >= 0.0 and clickWhenReady.status == NOT_STARTED:
            # keep track of start time/frame for later
            clickWhenReady.tStart = t
            clickWhenReady.frameNStart = frameN  # exact frame index
            clickWhenReady.status = STARTED
            # keyboard checking is just starting
        if clickWhenReady.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in readyComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ready"-------
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "ready" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    
    # -------2.0 sec delay before showing numbers-------
    blnk = visual.TextStim(win, text=u"    ")
    blnk.draw()
    win.flip()
    core.wait(0.5)
    
    # set up handler to look after randomisation of conditions etc
    numbers72 = data.TrialHandler(nReps=1, method='sequential',
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(u'digit_WM_conditions.xlsx', selection=u'0,1,2,3,4,5,6'),
        seed=None, name='numbers72')
    thisExp.addLoop(numbers72)  # add the loop to the experiment
    thisNumbers72 = numbers72.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisNumbers72.rgb)
    if thisNumbers72 != None:
        for paramName in thisNumbers72.keys():
            exec(paramName + '= thisNumbers72.' + paramName)
    
    for thisNumbers72 in numbers72:
        currentLoop = numbers72
        # abbreviate parameter names if possible (e.g. rgb = thisNumbers72.rgb)
        if thisNumbers72 != None:
            for paramName in thisNumbers72.keys():
                exec(paramName + '= thisNumbers72.' + paramName)
        
        # ------Prepare to start Routine "seven2"-------
        t = 0
        seven2Clock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(2.000000)
        # update component parameters for each repeat
        seven2dig.setText(int(S72))
        # keep track of which components have finished
        seven2Components = [seven2dig]
        for thisComponent in seven2Components:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "seven2"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = seven2Clock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *seven2dig* updates
            if t >= 0.0 and seven2dig.status == NOT_STARTED:
                # keep track of start time/frame for later
                seven2dig.tStart = t
                seven2dig.frameNStart = frameN  # exact frame index
                seven2dig.setAutoDraw(True)
            frameRemains = 0.0 + 2.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if seven2dig.status == STARTED and t >= frameRemains:
                seven2dig.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in seven2Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "seven2"-------
        for thisComponent in seven2Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'numbers72'
    
    
    # ------Prepare to start Routine "wait"-------
    t = 0
    waitClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    subResp = event.BuilderKeyResponse()
    # keep track of which components have finished
    waitComponents = [qMark, subResp]
    for thisComponent in waitComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "wait"-------
    while continueRoutine:
        # get current time
        t = waitClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *qMark* updates
        if t >= 0.0 and qMark.status == NOT_STARTED:
            # keep track of start time/frame for later
            qMark.tStart = t
            qMark.frameNStart = frameN  # exact frame index
            qMark.setAutoDraw(True)
        
        # *subResp* updates
        if t >= 0.0 and subResp.status == NOT_STARTED:
            # keep track of start time/frame for later
            subResp.tStart = t
            subResp.frameNStart = frameN  # exact frame index
            subResp.status = STARTED
            # keyboard checking is just starting
            subResp.clock.reset()  # now t=0
        if subResp.status == STARTED:
            theseKeys = event.getKeys(keyList=['0', '1'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                subResp.keys = theseKeys[-1]  # just the last key pressed
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in waitComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "wait"-------
    for thisComponent in waitComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if subResp.keys in ['', [], None]:  # No response was made
        subResp.keys=None
    if subResp.keys == '0': # if subject got it wrong
        incorrect = 1 # set 'incorrect' to 1 so we know to run "endIfWrong" loop and end expt
    else:
        incorrect = 0
        scoreList.append(1)
        thisExp.addData('setScore',1)
    # the Routine "wait" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    endIfWrong = data.TrialHandler(nReps=incorrect, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='endIfWrong')
    thisExp.addLoop(endIfWrong)  # add the loop to the experiment
    thisEndIfWrong = endIfWrong.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
    if thisEndIfWrong != None:
        for paramName in thisEndIfWrong.keys():
            exec(paramName + '= thisEndIfWrong.' + paramName)
    
    for thisEndIfWrong in endIfWrong:
        currentLoop = endIfWrong
        # abbreviate parameter names if possible (e.g. rgb = thisEndIfWrong.rgb)
        if thisEndIfWrong != None:
            for paramName in thisEndIfWrong.keys():
                exec(paramName + '= thisEndIfWrong.' + paramName)
        
        # ------Prepare to start Routine "endTest"-------
        t = 0
        endTestClock.reset()  # clock
        frameN = -1
        continueRoutine = True
        routineTimer.add(5.000000)
        # update component parameters for each repeat
        # keep track of which components have finished
        endTestComponents = [goodJobEndTest]
        for thisComponent in endTestComponents:
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        
        # -------Start Routine "endTest"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = endTestClock.getTime()
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *goodJobEndTest* updates
            if t >= 0.0 and goodJobEndTest.status == NOT_STARTED:
                # keep track of start time/frame for later
                goodJobEndTest.tStart = t
                goodJobEndTest.frameNStart = frameN  # exact frame index
                goodJobEndTest.setAutoDraw(True)
            frameRemains = 0.0 + 5.0- win.monitorFramePeriod * 0.75  # most of one frame period left
            if goodJobEndTest.status == STARTED and t >= frameRemains:
                goodJobEndTest.setAutoDraw(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in endTestComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            # check for quit (the Esc key)
            if endExpNow or event.getKeys(keyList=["escape"]):
                core.quit()
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "endTest"-------
        for thisComponent in endTestComponents:
            if incorrect == 1:
                endExpNow = True #subject got two lists of this length wrong
                print "Score for ",expInfo['participant']," is ",sum(scoreList[2:-1])+scoreList[-1]
                print "scoreList: ",scoreList
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
                
    # completed subResp repeats of 'endIfWrong'
    
# completed subResp repeats of 'runIfWrong'

# -------Show "Good Job!" for the rarity that makes it here.-------
blnk = visual.TextStim(win, text=u"Good Job! (End Test)")
blnk.draw()
win.flip()
core.wait(3.0)

print "Score for ",expInfo['participant']," is ",sum(scoreList[2:-1])+scoreList[-1]
print "scoreList: ",scoreList

# END EXPERIMENT
# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
